import BaseLayer from '../core/BaseLayer';
import { IGeometryLayerStyleOptions } from '../core/interface';
import { GeometryModelType } from './models';
export default class GeometryLayer extends BaseLayer<IGeometryLayerStyleOptions> {
    type: string;
    defaultSourceConfig: {
        data: {
            x: number;
            y: number;
        }[];
        options: {
            parser: {
                type: string;
                x: string;
                y: string;
            };
        };
    };
    buildModels(): void;
    rebuildModels(): void;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {} | {} | {};
    protected getModelType(): GeometryModelType;
}
