import BaseLayer from '../core/BaseLayer';
import { ILayer } from '@antv/l7-core';
import { ICanvasLayerStyleOptions } from '../core/interface';
import { CanvasModelType } from './models/index';
export default class CanvasLayer extends BaseLayer<ICanvasLayerStyleOptions> {
    type: string;
    forceRender: boolean;
    buildModels(): void;
    rebuildModels(): void;
    hide(): ILayer;
    renderModels(): this;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {};
    protected getModelType(): CanvasModelType;
}
