import { IAttributeAndElements } from '@antv/l7-core';
import BaseLayer from '../core/BaseLayer';
import { IHeatMapLayerStyleOptions } from '../core/interface';
import { HeatMapModelType } from './models';
export default class HeatMapLayer extends BaseLayer<IHeatMapLayerStyleOptions> {
    type: string;
    buildModels(): void;
    rebuildModels(): void;
    renderModels(): this;
    updateModelData(data: IAttributeAndElements): void;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getModelType(): HeatMapModelType;
}
