import BaseLayer from '../core/BaseLayer';
import { ILineLayerStyleOptions } from '../core/interface';
import { LineModelType } from './models';
export default class LineLayer extends BaseLayer<ILineLayerStyleOptions> {
    type: string;
    arrowInsertCount: number;
    defaultSourceConfig: {
        data: {
            lng1: number;
            lat1: number;
            lng2: number;
            lat2: number;
        }[];
        options: {
            parser: {
                type: string;
                x: string;
                y: string;
                x1: string;
                y1: string;
            };
        };
    };
    buildModels(): void;
    rebuildModels(): void;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {} | {} | {} | {} | {
        blend: string;
    } | {
        blend: string;
    } | {
        blend: string;
    } | {} | {} | {} | {};
    protected getModelType(): LineModelType;
}
