import BaseLayer from '../core/BaseLayer';
import { IPolygonLayerStyleOptions } from '../core/interface';
import { PolygonModelType } from './models/';
export default class PolygonLayer extends BaseLayer<IPolygonLayerStyleOptions> {
    type: string;
    defaultSourceConfig: {
        data: [];
        options: {
            parser: {
                type: 'geojson';
            };
        };
    };
    buildModels(): void;
    rebuildModels(): void;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getModelType(): PolygonModelType;
    protected getPointModelType(): PolygonModelType;
}
