import { ILayer, IScaleValue } from '@antv/l7-core';
import EventEmitter from 'eventemitter3';
export interface ITileConfigManager {
    setConfig(key: string, value: any): void;
    checkConfig(layer: ILayer): void;
    on(event: string, fn: (...args: any[]) => void): void;
    getAttributeScale(layer: ILayer, name: string): IScaleValue;
}
export default class TileConfigManager extends EventEmitter {
    cacheConfig: Map<string, any>;
    checkConfigList: string[];
    constructor();
    setConfig(key: string, value: any): void;
    removeConfig(key: string): void;
    checkConfig(layer: ILayer): void;
    getAttributeScale(layer: ILayer, name: string): IScaleValue;
}
