import { IInteractionTarget, ILayer, IPickingService, IRendererService, ITilePickManager } from '@antv/l7-core';
import { EventEmitter } from 'eventemitter3';
export default class TilePickManager extends EventEmitter implements ITilePickManager {
    isLastPicked: boolean;
    private rendererService;
    private pickingService;
    private children;
    private parent;
    constructor(parent: ILayer, rendererService: IRendererService, pickingService: IPickingService, children: ILayer[]);
    /**
     *
     * @param layers
     */
    normalRender(layers: ILayer[]): void;
    pickRender(layers: ILayer[], target: IInteractionTarget): boolean;
    clearPick(): void;
    beforeHighlight(pickedColors: any): void;
    beforeSelect(pickedColors: any): void;
    protected renderMask(layer: ILayer): void;
    destroy(): void;
}
