import BaseLayer from '../../core/BaseLayer';
import { IRasterLayerStyleOptions } from '../../core/interface';
import RasterModel from '../../raster/models/rasterTile';
import RasterRgbModel from '../../raster/models/rasterRgb';
export default class RasterTiffLayer extends BaseLayer<Partial<IRasterLayerStyleOptions>> {
    type: string;
    buildModels(): void;
    rebuildModels(): void;
    protected getModelType(): typeof RasterModel | typeof RasterRgbModel;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {};
}
