import BaseLayer from '../../core/BaseLayer';
import { ILineLayerStyleOptions, IPointLayerStyleOptions, IPolygonLayerStyleOptions } from '../../core/interface';
import lineFillModel from '../../line/models/tile';
import lineSimpleModel from '../../line/models/simpleTileLine';
import pointTextModel from '../../point/models/tileText';
import pointFillModel from '../../point/models/tile';
import polygonFillModel from '../../polygon/models/tile';
export default class VectorLayer extends BaseLayer<Partial<IPolygonLayerStyleOptions & ILineLayerStyleOptions & IPointLayerStyleOptions & {
    needListen: boolean;
}>> {
    needListen: boolean;
    isVector: boolean;
    type: string;
    private pickedID;
    init(): this;
    renderModels(isPicking?: boolean): this;
    protected sourceEvent: () => void;
    getPickID(): number | null;
    setPickID(): number | null;
    buildModels(): void;
    rebuildModels(): void;
    protected getModelType(): typeof lineFillModel | typeof lineSimpleModel | typeof pointTextModel | typeof pointFillModel | typeof polygonFillModel;
    protected getLineModel(): typeof lineFillModel | typeof lineSimpleModel;
    protected getPointModel(): typeof pointTextModel | typeof pointFillModel;
    protected getConfigSchema(): {
        properties: {
            opacity: {
                type: string;
                minimum: number;
                maximum: number;
            };
        };
    };
    protected getDefaultConfig(): {};
}
