import { ILayer, ILayerService, IMapService, IBaseTileLayer, IBaseTileLayerManager, ITileLayerOPtions } from '@antv/l7-core';
import { Tile, TilesetManager } from '@antv/l7-utils';
export default class BaseTileLayer implements IBaseTileLayer {
    get children(): ILayer[];
    type: string;
    sourceLayer: string;
    parent: ILayer;
    initedTileset: boolean;
    tilesetManager: TilesetManager | undefined;
    tileLayerManager: IBaseTileLayerManager;
    scaleField: any;
    private lastViewStates;
    protected mapService: IMapService;
    protected layerService: ILayerService;
    constructor({ parent, rendererService, mapService, layerService, }: ITileLayerOPtions);
    /**
     * 渲染瓦片的图层
     */
    render(): void;
    tileLoaded(tile: Tile): void;
    tileError(error: Error): void;
    tileUnLoad(tile: Tile): void;
    tileUpdate(): void;
    private initTileSetManager;
    private mapchange;
    private bindTilesetEvent;
    viewchange: import("lodash").DebouncedFunc<() => void>;
    private getCurrentView;
    destroy(): void;
}
