import { ILayer } from '@antv/l7-core';
/**
 * 该文件中的工具方法主要用于对 style 中的属性进行 数据映射
 */
interface IConfigToUpdate {
    thetaOffset?: any;
    opacity?: any;
    strokeOpacity?: any;
    stroke?: any;
    strokeWidth?: any;
    offsets?: any;
    textOffset?: any;
}
/**
 * 当样式发生变化时判断是否需要进行数据映射
 * @param configToUpdate
 * @param layer
 */
declare function handleStyleDataMapping(configToUpdate: IConfigToUpdate, layer: any): void;
/**
 * 根据传入参数 float 的类型和值做相应的操作
 */
declare function handleStyleFloat(fieldName: string, layer: ILayer, styleFloat: any): void;
/**
 * 根据传入参数 stroke / color 的类型和值做相应的操作
 * @param fieldName
 * @param layer
 * @param styleColor
 */
declare function handleStyleColor(fieldName: string, layer: ILayer, styleColor: any): void;
export { handleStyleDataMapping, handleStyleFloat, handleStyleColor };
