"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _classCallCheck2 = _interopRequireDefault(require("@babel/runtime/helpers/classCallCheck"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _inherits2 = _interopRequireDefault(require("@babel/runtime/helpers/inherits"));

var _possibleConstructorReturn2 = _interopRequireDefault(require("@babel/runtime/helpers/possibleConstructorReturn"));

var _getPrototypeOf2 = _interopRequireDefault(require("@babel/runtime/helpers/getPrototypeOf"));

var _base = _interopRequireDefault(require("./base"));

var _vectorLayer = _interopRequireDefault(require("./vectorLayer"));

var _utils = require("../utils");

function _createSuper(Derived) { var hasNativeReflectConstruct = _isNativeReflectConstruct(); return function _createSuperInternal() { var Super = (0, _getPrototypeOf2.default)(Derived), result; if (hasNativeReflectConstruct) { var NewTarget = (0, _getPrototypeOf2.default)(this).constructor; result = Reflect.construct(Super, arguments, NewTarget); } else { result = Super.apply(this, arguments); } return (0, _possibleConstructorReturn2.default)(this, result); }; }

function _isNativeReflectConstruct() { if (typeof Reflect === "undefined" || !Reflect.construct) return false; if (Reflect.construct.sham) return false; if (typeof Proxy === "function") return true; try { Boolean.prototype.valueOf.call(Reflect.construct(Boolean, [], function () {})); return true; } catch (e) { return false; } }

var TestTile = /*#__PURE__*/function (_TileFactory) {
  (0, _inherits2.default)(TestTile, _TileFactory);

  var _super = _createSuper(TestTile);

  function TestTile(option) {
    var _this;

    (0, _classCallCheck2.default)(this, TestTile);
    _this = _super.call(this, option);
    _this.parentLayer = option.parent;
    return _this;
  }

  (0, _createClass2.default)(TestTile, [{
    key: "createTile",
    value: function createTile(tile, initOptions) {
      var sourceLayer = initOptions.sourceLayer;

      if (!sourceLayer) {
        return {
          layers: [],
          layerIDList: []
        };
      }

      var vectorTileLayer = tile.data.layers[sourceLayer];
      var features = vectorTileLayer === null || vectorTileLayer === void 0 ? void 0 : vectorTileLayer.features;

      if (features.length === 0) {
        return {
          layers: [],
          layerIDList: []
        };
      }

      var properties = features[0].properties;
      var text = new _vectorLayer.default({
        layerType: 'PointLayer',
        usage: 'basemap',
        needListen: false
      }).source([properties], {
        parser: {
          type: 'json',
          x: 'textLng',
          y: 'textLat',
          cancelExtent: true
        }
      }).shape('key', 'text').style({
        size: 20,
        color: '#000',
        stroke: '#fff',
        strokeWidth: 2
      });
      var line = new _vectorLayer.default({
        layerType: 'LineLayer',
        usage: 'basemap',
        needListen: false
      }).source({
        type: 'FeatureCollection',
        features: features
      }, {
        parser: {
          type: 'geojson',
          cancelExtent: true
        }
      }).shape('simple').style({
        color: '#000'
      }); // Tip: sign tile layer

      text.isTileLayer = true;
      line.isTileLayer = true;
      (0, _utils.registerLayers)(this.parentLayer, [line, text]);
      text.once('modelLoaded', function () {
        tile.layerLoad();
      });
      line.once('modelLoaded', function () {
        tile.layerLoad();
      });
      return {
        layers: [line, text],
        layerIDList: [line.id, text.id]
      };
    }
  }]);
  return TestTile;
}(_base.default);

exports.default = TestTile;